//===========================================================================
// Released under Anonymity
// Feel free to embrace and extend this code!
// 11/16/02
// 
// ResourceExtractorState_ClosingFile.cpp
// 
// Implementation of transient state that closes a resource
// file after data has been extracted to it
//===========================================================================

//===========================================================================
// Included Files
//===========================================================================
#include "projectpch.h"
#include "ResourceExtractor.h"

//===========================================================================
// Definition of Constructor: CResourceExtractor::ClosingFile::
//                          ClosingFile(CResourceExtractor* pOwningExtractor)       
//
// This constructor simply defers to the super class constructor
//===========================================================================
CResourceExtractor::ClosingFile::ClosingFile(CResourceExtractor* pOwningExtractor)
:TransientState(pOwningExtractor)
{
}

//===========================================================================
// Definition of Method: CResourceExtractor::ClosingFile::beginState()
//
// beginState in ClosingFile closes the current resource file, and advises
// the listener.  Then it sends the extractor back to SearchingForStart.
//===========================================================================
void CResourceExtractor::ClosingFile::beginState()
{
	fclose(m_pOwner->m_poutfile);
	if (m_pOwner->m_output)
		m_pOwner->m_output->onFileClose(m_pOwner->m_szCurrFileName,m_pOwner->m_FilePos,m_pOwner->m_CurrFileSize,m_pOwner->m_numTrailingBytes);
	m_pOwner->m_numTrailingBytes=0;
	m_pOwner->m_poutfile=NULL;
	m_pOwner->GotoState(new SearchingForStart(m_pOwner));
	return;
}

