//===========================================================================
// Released under Anonymity
// Feel free to embrace and extend this code!
// 11/16/02
// 
// ResourceExtractorState_CreatingFile.cpp
// 
// Implementation of a transient resource extractor state that creates
// an output file into which a resource is to be extracted
//===========================================================================

//===========================================================================
// Included Files
//===========================================================================
#include "projectpch.h"
#include "ResourceExtractor.h"

//===========================================================================
// Definition of Constructor: CResourceExtractor::CreatingFile::
//                         CreatingFile(CResourceExtractor* pOwningExtractor)       
//
// This constructor simply defers to the super class constructor
//===========================================================================
CResourceExtractor::CreatingFile::CreatingFile(CResourceExtractor* pOwningExtractor)
:TransientState(pOwningExtractor)
{
}

//===========================================================================
// Definition of Method: CResourceExtractor::CreatingFile::beginState()
//
// beginState in CreatingFile creates a new resource file and then
// immediately goes to the ExtractingFile state.  (this is a transient state)
//===========================================================================
void CResourceExtractor::CreatingFile::beginState()
{
	m_pOwner->getOutFilename();
	m_pOwner->m_poutfile=fopen(m_pOwner->m_szCurrFileName,"wb");
	m_pOwner->m_CurrFileSize=0;

	if (m_pOwner->m_output)
		m_pOwner->m_output->onFileOpen(m_pOwner->m_szCurrFileName,m_pOwner->m_FilePos);
	for (int i=0;i<m_pOwner->m_startcomparelen;++i)
	{
		++m_pOwner->m_CurrFileSize;
		fputc(m_pOwner->m_szStartCompareString[i],m_pOwner->m_poutfile);
	}
	m_pOwner->GotoState(new ExtractingFile(m_pOwner));
	return;		
}
